/*
 * nasced / sanio pulcod encoder
 * Copyright (c) 2010, Robert Mazur (rm@nateo.pl)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 or later
 * <http://gnu.org/licenses/gpl.html>.
 *
 * Alternatively, this software may be distributed under the terms of Simplified BSD
 * License.
 *
 * Copyright 2010, Robert Mazur. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, are
 * permitted provided that the following conditions are met:
 * 
 *    1. Redistributions of source code must retain the above copyright notice, this list of
 *       conditions and the following disclaimer.
 * 
 *    2. Redistributions in binary form must reproduce the above copyright notice, this list
 *       of conditions and the following disclaimer in the documentation and/or other materials
 *       provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are those of the
 * authors and should not be interpreted as representing official policies, either expressed
 * or implied, of Robert Mazur.
 * 
 *
 */ 
 

#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h> 
#include <unistd.h>
#include <sys/stat.h>
#include <math.h>

short pulcod_flag_1;
int   pulcod_flag_2;

int   pulcod_buf_size2;
int   pulcod_buf_size;
int16_t pulcod_var1;
int16_t var_word_3;
int16_t flag_1;
int16_t tab_tmp_out[22];
int16_t tab_tmp_in[325];
int16_t tab_word[325];
int16_t tab_dword2[10];
int16_t tab_dword1[10];
int16_t tab_dword1_0[10];
int16_t tab_word_0[16]; // max 10
int16_t pulcod_frame[9];
int16_t pulcod_buf_end;
int16_t pulcod_buf_2[0x120];
int16_t var_word_491;
int16_t buf_word_x4[40];
int16_t tab_int_16384[11];
int16_t tab_int_22938[11];
int16_t tab_int1[10];
int var_int_calcul;
double var_doubl_calcul;
const int16_t data_const5[10]=
{
30000,26000,21000,15000,8000, 0,57536,50536,44536,39536
};
const int16_t buf_const10[10]=
{
	2339,
	4679,
	7018,
	9358,
	11698,
	14037,
	16377,
	18717,
	21056,
	23396,
};

const int16_t buf_const4[20]=
{
7798,8447,8205,8293,8126,8477,8447,8703,9043,8604,14585,
18333,19772,17344,16426,16459,15155,15220,16043,15708
};
const int16_t buf_const5[20]=
{
17210, 15888, 16357, 16183, 16516, 15833, 15888, 15421,
14840, 15597, 9202, 7320, 6788, 7738, 8170, 8154, 8856,
8818, 8366, 8544
};

const int16_t tab_const_xx[]=
{
32767, 25207, 14700, 0, 61135, 59686, 0, 1210, 3130,
0, 0, 63885, 0, 65072, 756, 0, 549, 65292, 0, 65086,
0, 0, 295, 78, 0, 65372, 65458, 0, 91, 70, 0, 0, 2621,
2622, 2626, 2632, 2640, 2650, 2662, 2677, 2694, 2714,
2735, 2759, 2785, 2814, 2844, 2877, 2912, 2949, 2989,
3031, 3075, 3121, 3169, 3220, 3273, 3328, 3385, 3444,
3506, 3569, 3635, 3703, 3773, 3845, 3919, 3996, 4074,
4155, 4237, 4321, 4408, 4496, 4587, 4680, 4774, 4870,
4969, 5069, 5171, 5275, 5381, 5489, 5599, 5710, 5824,
5939, 6056, 6174, 6295, 6417, 6541, 6666, 6793, 6922,
7052, 7185, 7318, 7453
};

const int16_t table_1[64]=
{32767,32729,32610,32413,32138,31786,31357,30853,30274,
29622,28899,28106,27246,26320,25330,24279,23170,22006,
20788,19520,18205,16846,15447,14010,12540,11039,9512,
7962,6393,4808,3212,1608, 0,63928,62324,60728,59143,
57574,56024,54497,52996,51526,50089,48690,47331,46016,
44748,43530,42366,41257,40206,39216,38290,37430,36637,
35914,35262,34683,34179,33750,33398,33123,32926,32807,
};

const int16_t table_2[64]=
{64904,63643,62386,61137,59898,58673,57464,56275,55108,
53966,52852,51769,50719,49704,48728,47792,46899,46050,
45249,44497,43795,43146,42550,42010,41527,41101,40735,
40428,40182,39996,39872,39810,39810,39872,39996,40182,
40428,40735,41101,41527,42010,42550,43146,43795,44497,
45249,46050,46899,47792,48728,49704,50719,51769,52852,
53966,55108,56275,57464,58673,59898,61137,62386,63643,
};

const int16_t tab_int4[80]=
{
8421, 9109, 9175, 8965, 9034, 9057, 8765, 8775, 9106,
8673, 7018, 7189, 7638, 7307, 7444, 7379, 7038, 6956,
6930, 6868, 5472, 4990, 5134, 5177, 5246, 5141, 5206,
5095, 4830, 5147, 4056, 3031, 2614, 3024, 2916, 2713,
3309, 3237, 2857, 3473, 7733, 7880, 8188, 8175, 8247,
8490, 8637, 8601, 8359, 7569, 4210, 3031, 2552, 3473,
3876, 3853, 4184, 4154, 3909, 3968, 3214, 1930, 1313,
2143, 2493, 2385, 2755, 2706, 2542, 2919, 3024, 1592,
940, 1631, 1723, 1579, 2034, 2084, 1913, 2601
};


const int16_t buf_const_in[1280]=
{
1486, 2168, 3751, 9074, 12134, 13944, 17983, 19173,
21190, 21820, 1730, 2640, 3450, 4870, 6126, 7876, 15644,
17817, 20294, 21902, 1568, 2256, 3088, 4874, 11063,
13393, 18307, 19293, 21109, 21741, 1733, 2512, 3357,
4708, 6977, 10296, 17024, 17956, 19145, 20350, 1744,
2436, 3308, 8731, 10432, 12007, 15614, 16639, 21359,
21913, 1786, 2369, 3372, 4521, 6795, 12963, 17674, 18988,
20855, 21640, 1631, 2433, 3361, 6328, 10709, 12013,
13277, 13904, 19441, 21088, 1489, 2364, 3291, 6250,
9227, 10403, 13843, 15278, 17721, 21451, 1869, 2533,
3475, 4365, 9152, 14513, 15908, 17022, 20611, 21411,
2070, 3025, 4333, 5854, 7805, 9231, 10597, 16047, 20109,
21834, 1910, 2673, 3419, 4261, 11168, 15111, 16577,
17591, 19310, 20265, 1141, 1815, 2624, 4623, 6495, 9588,
13968, 16428, 19351, 21286, 2192, 3171, 4707, 5808,
10904, 12500, 14162, 15664, 21124, 21789, 1286, 1907,
2548, 3453, 9574, 11964, 15978, 17344, 19691, 22495,
1921, 2720, 4604, 6684, 11503, 12992, 14350, 15262,
16997, 20791, 2052, 2759, 3897, 5246, 6638, 10267, 15834,
16814, 18149, 21675, 1798, 2497, 5617, 11449, 13189,
14711, 17050, 18195, 20307, 21182, 1009, 1647, 2889,
5709, 9541, 12354, 15231, 18494, 20966, 22033, 3016,
3794, 5406, 7469, 12488, 13984, 15328, 16334, 19952,
20791, 2203, 3040, 3796, 5442, 11987, 13512, 14931,
16370, 17856, 18803, 2912, 4292, 7988, 9572, 11562,
13244, 14556, 16529, 20004, 21073, 2861, 3607, 5923,
7034, 9234, 12054, 13729, 18056, 20262, 20974, 3069,
4311, 5967, 7367, 11482, 12699, 14309, 16233, 18333,
19172, 2434, 3661, 4866, 5798, 10383, 11722, 13049,
15668, 18862, 19831, 2020, 2605, 3860, 9241, 13275,
14644, 16010, 17099, 19268, 20251, 1877, 2809, 3590,
4707, 11056, 12441, 15622, 17168, 18761, 19907, 2107,
2873, 3673, 5799, 13579, 14687, 15938, 17077, 18890,
19831, 1612, 2284, 2944, 3572, 8219, 13959, 15924, 17239,
18592, 20117, 2420, 3156, 6542, 10215, 12061, 13534,
15305, 16452, 18717, 19880, 1667, 2612, 3534, 5237,
10513, 11696, 12940, 16798, 18058, 19378, 2388, 3017,
4839, 9333, 11413, 12730, 15024, 16248, 17449, 18677,
1875, 2786, 4231, 6320, 8694, 10149, 11785, 17013, 18608,
19960, 679, 1411, 4654, 8006, 11446, 13249, 15763, 18127,
20361, 21567, 1838, 2596, 3578, 4608, 5650, 11274, 14355,
15886, 20579, 21754, 1303, 1955, 2395, 3322, 12023,
13764, 15883, 18077, 20180, 21232, 1438, 2102, 2663,
3462, 8328, 10362, 13763, 17248, 19732, 22344, 860,
1904, 6098, 7775, 9815, 12007, 14821, 16709, 19787,
21132, 1673, 2723, 3704, 6125, 7668, 9447, 13683, 14443,
20538, 21731, 1246, 1849, 2902, 4508, 7221, 12710, 14835,
16314, 19335, 22720, 1525, 2260, 3862, 5659, 7342, 11748,
13370, 14442, 18044, 21334, 1196, 1846, 3104, 7063,
10972, 12905, 14814, 17037, 19922, 22636, 2147, 3106,
4475, 6511, 8227, 9765, 10984, 12161, 18971, 21300,
1585, 2405, 2994, 4036, 11481, 13177, 14519, 15431,
19967, 21275, 1778, 2688, 3614, 4680, 9465, 11064, 12473,
16320, 19742, 20800, 1862, 2586, 3492, 6719, 11708,
13012, 14364, 16128, 19610, 20425, 1395, 2156, 2669,
3386, 10607, 12125, 13614, 16705, 18976, 21367, 1444,
2117, 3286, 6233, 9423, 12981, 14998, 15853, 17188,
21857, 2004, 2895, 3783, 4897, 6168, 7297, 12609, 16445,
19297, 21465, 1495, 2863, 6360, 8100, 11399, 14271,
15902, 17711, 20479, 22061, 2484, 3114, 5718, 7097,
8400, 12616, 14073, 14847, 20535, 21396, 2424, 3277,
5296, 6284, 11290, 12903, 16022, 17508, 19333, 20283,
2565, 3778, 5360, 6989, 8782, 10428, 14390, 15742, 17770,
21734, 2727, 3384, 6613, 9254, 10542, 12236, 14651,
15687, 20074, 21102, 1916, 2953, 6274, 8088, 9710, 10925,
12392, 16434, 20010, 21183, 3384, 4366, 5349, 7667,
11180, 12605, 13921, 15324, 19901, 20754, 3075, 4283,
5951, 7619, 9604, 11010, 12384, 14006, 20658, 21497,
1751, 2455, 5147, 9966, 11621, 13176, 14739, 16470,
20788, 21756, 1442, 2188, 3330, 6813, 8929, 12135, 14476,
15306, 19635, 20544, 2294, 2895, 4070, 8035, 12233,
13416, 14762, 17367, 18952, 19688, 1937, 2659, 4602,
6697, 9071, 12863, 14197, 15230, 16047, 18877, 2071,
2663, 4216, 9445, 10887, 12292, 13949, 14909, 19236,
20341, 1740, 2491, 3488, 8138, 9656, 11153, 13206, 14688,
20896, 21907, 2199, 2881, 4675, 8527, 10051, 11408,
14435, 15463, 17190, 20597, 1943, 2988, 4177, 6039,
7478, 8536, 14181, 15551, 17622, 21579, 1825, 3175,
7062, 9818, 12824, 15450, 18330, 19856, 21830, 22412,
2464, 3046, 4822, 5977, 7696, 15398, 16730, 17646, 20588,
21320, 2550, 3393, 5305, 6920, 10235, 14083, 18143,
19195, 20681, 21336, 3003, 3799, 5321, 6437, 7919, 11643,
15810, 16846, 18119, 18980, 3455, 4157, 6838, 8199,
9877, 12314, 15905, 16826, 19949, 20892, 3052, 3769,
4891, 5810, 6977, 10126, 14788, 15990, 19773, 20904,
3671, 4356, 5827, 6997, 8460, 12084, 14154, 14939, 19247,
20423, 2716, 3684, 5246, 6686, 8463, 10001, 12394, 14131,
16150, 19776, 1945, 2638, 4130, 7995, 14338, 15576,
17057, 18206, 20225, 20997, 2304, 2928, 4122, 4824,
5640, 13139, 15825, 16938, 20108, 21054, 1800, 2516,
3350, 5219, 13406, 15948, 17618, 18540, 20531, 21252,
1436, 2224, 2753, 4546, 9657, 11245, 15177, 16317, 17489,
19135, 2319, 2899, 4980, 6936, 8404, 13489, 15554, 16281,
20270, 20911, 2187, 2919, 4610, 5875, 7390, 12556, 14033,
16794, 20998, 21769, 2235, 2923, 5121, 6259, 8099, 13589,
15340, 16340, 17927, 20159, 1765, 2638, 3751, 5730,
7883, 10108, 13633, 15419, 16808, 18574, 3460, 5741,
9596, 11742, 14413, 16080, 18173, 19090, 20845, 21601,
3735, 4426, 6199, 7363, 9250, 14489, 16035, 17026, 19873,
20876, 3521, 4778, 6887, 8680, 12717, 14322, 15950,
18050, 20166, 21145, 2141, 2968, 6865, 8051, 10010,
13159, 14813, 15861, 17528, 18655, 4148, 6128, 9028,
10871, 12686, 14005, 15976, 17208, 19587, 20595, 4403,
5367, 6634, 8371, 10163, 11599, 14963, 16331, 17982,
18768, 4091, 5386, 6852, 8770, 11563, 13290, 15728,
16930, 19056, 20102, 2746, 3625, 5299, 7504, 10262,
11432, 13172, 15490, 16875, 17514, 2248, 3556, 8539,
10590, 12665, 14696, 16515, 17824, 20268, 21247, 1279,
1960, 3920, 7793, 10153, 14753, 16646, 18139, 20679,
21466, 2440, 3475, 6737, 8654, 12190, 14588, 17119,
17925, 19110, 19979, 1879, 2514, 4497, 7572, 10017,
14948, 16141, 16897, 18397, 19376, 2804, 3688, 7490,
10086, 11218, 12711, 16307, 17470, 20077, 21126, 2023,
2682, 3873, 8268, 10255, 11645, 15187, 17102, 18965,
19788, 2823, 3605, 5815, 8595, 10085, 11469, 16568,
17462, 18754, 19876, 2851, 3681, 5280, 7648, 9173, 10338,
14961, 16148, 17559, 18474, 1348, 2645, 5826, 8785,
10620, 12831, 16255, 18319, 21133, 22586, 2141, 3036,
4293, 6082, 7593, 10629, 17158, 18033, 21466, 22084,
1608, 2375, 3384, 6878, 9970, 11227, 16928, 17650, 20185,
21120, 2774, 3616, 5014, 6557, 7788, 8959, 17068, 18302,
19537, 20542, 1934, 4813, 6204, 7212, 8979, 11665, 15989,
17811, 20426, 21703, 2288, 3507, 5037, 6841, 8278, 9638,
15066, 16481, 21653, 22214, 2951, 3771, 4878, 7578,
9016, 10298, 14490, 15242, 20223, 20990, 3256, 4791,
6601, 7521, 8644, 9707, 13398, 16078, 19102, 20249,
1827, 2614, 3486, 6039, 12149, 13823, 16191, 17282,
21423, 22041, 1000, 1704, 3002, 6335, 8471, 10500, 14878,
16979, 20026, 22427, 1646, 2286, 3109, 7245, 11493,
12791, 16824, 17667, 18981, 20222, 1708, 2501, 3315,
6737, 8729, 9924, 16089, 17097, 18374, 19917, 2623,
3510, 4478, 5645, 9862, 11115, 15219, 18067, 19583,
20382, 2518, 3434, 4728, 6388, 8082, 9285, 13162, 18383,
19819, 20552, 1726, 2383, 4090, 6303, 7805, 12845, 14612,
17608, 19269, 20181, 2860, 3735, 4838, 6044, 7254, 8402,
14031, 16381, 18037, 19410, 4247, 5993, 7952, 9792,
12342, 14653, 17527, 18774, 20831, 21699, 3502, 4051,
5680, 6805, 8146, 11945, 16649, 17444, 20390, 21564,
3151, 4893, 5899, 7198, 11418, 13073, 15124, 17673,
20520, 21861, 3960, 4848, 5926, 7259, 8811, 10529, 15661,
16560, 18196, 20183, 4499, 6604, 8036, 9251, 10804,
12627, 15880, 17512, 20020, 21046, 4251, 5541, 6654,
8318, 9900, 11686, 15100, 17093, 20572, 21687, 3769,
5327, 7865, 9360, 10684, 11818, 13660, 15366, 18733,
19882, 3083, 3969, 6248, 8121, 9798, 10994, 12393, 13686,
17888, 19105, 2731, 4670, 7063, 9201, 11346, 13735,
16875, 18797, 20787, 22360, 1187, 2227, 4737, 7214,
9622, 12633, 15404, 17968, 20262, 23533, 1911, 2477,
3915, 10098, 11616, 12955, 16223, 17138, 19270, 20729,
1764, 2519, 3887, 6944, 9150, 12590, 16258, 16984, 17924,
18435, 1400, 3674, 7131, 8718, 10688, 12508, 15708,
17711, 19720, 21068, 2322, 3073, 4287, 8108, 9407, 10628,
15862, 16693, 19714, 21474, 2630, 3339, 4758, 8360,
10274, 11333, 12880, 17374, 19221, 19936, 1721, 2577,
5553, 7195, 8651, 10686, 15069, 16953, 18703, 19929,
};

 const int16_t buf_const_in2[320]=
 {
-435, -815, -742, 1033, -518, 582, -1201, 829, 86, 385,
-833, -891, 463, -8, -1251, 1450, 72, -231, 864, 661,
-1021, 231, -306, 321, -220, -163, -526, -754, -1633,
267, 57, -198, -339, -33, -1468, 573, 796, -169, -631,
816, 171, -350, 294, 1660, 453, 519, 291, 159, -640,
-1296, -701, -842, -58, 950, 892, 1549, 715, 527, -714,
-193, 584, 31, -289, 356, -333, -457, 612, -283, -1381,
-741, -109, -808, 231, 77, -87, -344, 1341, 1087, -654,
-569, -859, 1236, 550, 854, 714, -543, -1752, -195,
-98, -276, -877, -954, -1248, -299, 212, -235, -728,
949, 1517, 895, -77, 344, -620, 763, 413, 502, -362,
-960, -483, 1386, -314, -307, -256, -1260, -429, 450,
-466, -108, 1010, 2223, 711, 693, 521, 650, 1305, -28,
-378, 744, -1005, 240, -112, -271, -500, 946, 1733,
271, -15, 909, -259, 1688, 575, -10, -468, -199, 1101,
-1011, 581, -53, -747, 878, 145, -285, -1280, -398,
36, -498, -1377, 18, -444, 1483, -1133, -835, 1350,
1284, -95, 1015, -222, 443, 372, -354, -1459, -1237,
416, -213, 466, 669, 659, 1640, 932, 534, -15, 66, 468,
1019, -748, 1385, -182, -907, -721, -262, -338, 148,
1445, 75, -760, 569, 1247, 337, 416, -121, 389, 239,
1568, 981, 113, 369, -1003, -507, -587, -904, -312,
-98, 949, 31, 1104, 72, -141, 1465, 63, -785, 1127,
584, 835, 277, -1159, 208, 301, -882, 117, -404, 539,
-114, 856, -493, 223, -912, 623, -76, 276, -440, 2197,
2337, 1268, 670, 304, -267, -525, 140, 882, -139, -1596,
550, 801, -456, -56, -697, 865, 1060, 413, 446, 1154,
593, -77, 1237, -31, 581, -1037, -895, 669, 297, 397,
558, 203, -797, -919, 3, 692, -292, 1050, 782, 334,
1475, 632, -80, 48, -1061, -484, 362, -597, -852, -545,
-330, -429, -680, 1133, -1182, -744, 1340, 262, 63,
1320, 827, -398, -576, 341, -774, -483, -1247, -70,
98, -163, 674, -11, -886, 531, -1125, -265, -242, 724,
934
};

const int16_t ptr_dword1[2] ={8192, 4096};

const int16_t const_table[896]=
{ 
17152, 457, 17957, 6, 48384, 65079, 239, 19079, 113,
22218, 0, 46457, 65423, 66, 6861, 278, 2873, 2, 58675,
65258, 58, 19610, 5152, 23473, 810, 45926, 60384, 3083,
19611, 1725, 23474, 90, 45925, 63811, 1032, 17877, 1067,
19507, 34, 47659, 64469, 582, 13453, 493, 11046, 7,
52083, 65043, 202, 19629, 13332, 23518, 5424, 45907,
52204, 7986, 15135, 1704, 13981, 88, 50401, 63832, 787,
19541, 2265, 23306, 156, 45995, 63271, 1350, 8113, 221,
4018, 1, 57423, 65315, 54, 19558, 8937, 23347, 2437,
45978, 56599, 5334, 17755, 2703, 19241, 223, 47781,
62833, 1465, 13521, 1606, 11159, 78, 52015, 63930, 663,
15714, 225, 15071, 1, 49822, 65311, 108, 18212, 154,
20244, 0, 47324, 65382, 85, 15009, 1029, 13750, 32,
50527, 64507, 471, 14675, 2314, 13144, 163, 50861, 63222,
1036, 8230, 886, 4134, 23, 57306, 64650, 222, 19595,
11425, 23437, 3983, 45941, 54111, 6832, 19527, 3646,
23273, 405, 46009, 61890, 2172, 14530, 3666, 12887,
410, 51006, 61870, 1625, 11695, 1286, 8348, 50, 53841,
64250, 459, 19660, 16325, 23592, 8133, 45876, 49211,
9795, 50, 171, 0, 0, 65486, 65365, 0, 17288, 6258, 18243,
1195, 48248, 59278, 3301, 8069, 4814, 3974, 707, 57467,
60722, 1185, 10326, 247, 6508, 1, 55210, 65289, 78,
19551, 6335, 23330, 1224, 45985, 59201, 3779, 11464,
10217, 8022, 3186, 54072, 55319, 3575, 10960, 3080,
7332, 289, 54576, 62456, 1030, 7143, 3718, 3114, 421,
58393, 61818, 810, 15548, 4624, 14755, 652, 49988, 60912,
2194, 17294, 3678, 18255, 412, 48242, 61858, 1941, 4201,
1738, 1077, 92, 61335, 63798, 222, 116, 701, 0, 15,
65420, 64835, 2, 16940, 5132, 17516, 804, 48596, 60404,
2653, 13617, 6443, 11318, 1267, 51919, 59093, 2677,
11937, 4298, 8697, 563, 53599, 61238, 1566, 18942, 18374,
21901, 10303, 46594, 47162, 10622, 10934, 762, 7297,
17, 54602, 64774, 254, 15249, 5608, 14193, 959, 50287,
59928, 2610, 2971, 3175, 539, 307, 62565, 62361, 287,
17650, 14217, 19014, 6169, 47886, 51319, 7658, 19482,
7602, 23166, 1763, 46054, 57934, 4519, 19647, 978, 23561,
29, 45889, 64558, 586, 12984, 2829, 10290, 244, 52552,
62707, 1121, 19592, 1283, 23430, 50, 45944, 64253, 767,
13154, 5447, 10561, 905, 52382, 60089, 2186, 14516,
8411, 12861, 2159, 51020, 57125, 3726, 5747, 278, 2016,
2, 59789, 65258, 48, 14063, 146, 12071, 0, 51473, 65390,
62, 17982, 9253, 19736, 2613, 47554, 56283, 5078, 14987,
132, 13709, 0, 50549, 65404, 60, 10319, 5694, 6499,
989, 55217, 59842, 1793, 19660, 23571, 23592, 16956,
45876, 41965, 14143, 19525, 2893, 23269, 255, 46011,
62643, 1724, 19647, 716, 23560, 15, 45889, 64820, 429,
4516, 10733, 1245, 3515, 61020, 54803, 1479, 9494, 3617,
5502, 399, 56042, 61919, 1048, 1557, 317, 148, 3, 63979,
65219, 15, 15655, 3019, 14958, 278, 49881, 62517, 1442,
7013, 8758, 3002, 2341, 58523, 56778, 1874, 16870, 26989,
17370, 22230, 48666, 38547, 13895, 13352, 6843, 10881,
1429, 52184, 58693, 2788, 13164, 175, 10577, 0, 52372,
65361, 70, 2603, 5307, 413, 859, 62933, 60229, 421,
14610, 11667, 13029, 4154, 50926, 53869, 5202, 373,
1580, 8, 76, 65163, 63956, 18, 14219, 7433, 12340, 1686,
51317, 58103, 3225, 8490, 7223, 4400, 1592, 57046, 58313,
1871, 18670, 20284, 21275, 12556, 46866, 45252, 11557,
12119, 8271, 8964, 2087, 53417, 57265, 3059, 15465,
8372, 14598, 2139, 50071, 57164, 3951, 4706, 4696, 1352,
673, 60830, 60840, 674, 19644, 74, 23554, 0, 45892,
65462, 44, 15843, 680, 15320, 14, 49693, 64856, 328,
10156, 8176, 6296, 2040, 55380, 57360, 2534, 18721,
279, 21392, 2, 46815, 65257, 159, 14958, 6501, 13657,
1289, 50578, 59035, 2967, 10546, 7409, 6788, 1675, 54990,
58127, 2384, 12245, 8813, 9152, 2370, 53291, 56723,
3293, 5154, 7919, 1621, 1913, 60382, 57617, 1245, 15213,
17854, 14126, 9728, 50323, 47682, 8289, 12635, 806,
9744, 19, 52901, 64730, 311, 16474, 363, 16565, 4, 49062,
65173, 182, 5858, 7853, 2095, 1882, 59678, 57683, 1404,
9188, 280, 5153, 2, 56348, 65256, 78, 17902, 607, 19561,
11, 47634, 64929, 332, 2982, 318, 542, 3, 62554, 65218,
28, 17365, 1684, 18404, 86, 48171, 63852, 892, 7560,
6023, 3489, 1107, 57976, 59513, 1389, 14217, 13224,
12337, 5337, 51319, 52312, 5738, 4918, 18288, 1476,
10207, 60618, 47248, 2744, 12327, 177, 9275, 0, 53209,
65359, 66, 19415, 4392, 23008, 588, 46121, 61144, 2602,
10669, 11716, 6947, 4189, 54867, 53820, 3814, 13448,
9986, 11038, 3043, 52088, 55550, 4098, 866, 8679, 45,
2299, 64670, 56857, 229, 4417, 298, 1190, 2, 61119,
65238, 40, 14482, 11595, 12802, 4103, 51054, 53941,
5125, 0, 6122, 0, 1144, 0, 59414, 0, 18818, 710, 21614,
15, 46718, 64826, 407, 19640, 521, 23544, 8, 45896,
65015, 312, 9528, 1155, 5541, 40, 56008, 64381, 336,
19629, 254, 23517, 1, 45907, 65282, 152, 13797, 966,
11619, 28, 51739, 64570, 406, 7834, 2122, 3746, 137,
57702, 63414, 507, 19659, 158, 23589, 0, 45877, 65378,
94, 15292, 7415, 14272, 1678, 50244, 58121, 3460, 16720,
101, 17063, 0, 48816, 65435, 51, 5645, 26357, 1945,
21201, 59891, 39179, 4540, 7792, 12556, 3706, 4811,
57744, 52980, 2985, 17586, 150, 18877, 0, 47950, 65386,
80, 0, 12905, 0, 5082, 0, 52631, 0, 14685, 515, 13162,
8, 50851, 65021, 230, 16450, 2144, 16517, 140, 49086,
63392, 1076, 6505, 1040, 2583, 33, 59031, 64496, 206,
10691, 1990, 6977, 120, 54845, 63546, 649, 18411, 32686,
20690, 32604, 47125, 32850, 18365, 19537, 10239, 23299,
3199, 45999, 55297, 6105, 17289, 7212, 18244, 1587,
48247, 58324, 3805, 16485, 1210, 16587, 44, 49051, 64326,
608, 11218, 199, 7681, 1, 54318, 65337, 68, 26, 3602,
0, 396, 65510, 61934, 2, 19651, 364, 23569, 4, 45885,
65172, 218, 11873, 467, 8605, 6, 53663, 65069, 169,
977, 32686, 58, 32604, 64559, 32850, 975
};

const int16_t sign_tab[]=
{1, 0, 1, 0, 1, 0, 0, 1, 1, 0, 1, 1, 1, 0, 1, -1, 0,
1, 1, 0, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, -1, 1, 1,
1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, -1, 1, -1, 1,
0, 1, -1, 0, 1, 1, -1, 1, 1, 1, -1, 1, -1, 1, 0, -1,
0, 1, 0, 0, -1, 1, 0, -1, -1, 1, 0, -1, 1, 0, 1, -1,
0, 0, 1, 0, -1, 0, 1, -1, -1, 0, 1, -1, 1, 1, 1, -1,
0, 1, 1, 0, -1, 1, 1, -1, -1, 1, 1, -1, 1, 1, -1, -1,
0, 1, -1, 0, -1, 1, -1, -1, -1, 1, -1, -1, 1, -1, 0,
-1, 0, -1, 0, 0, -1, -1, 0, -1, -1, -1, 0, -1, 1, 0,
-1, -1, 0, 0, -1, 0, -1, 0, -1, -1, -1, 0, -1, -1, 1,
-1, -1, -1, 0, -1, -1, 0, -1, -1, -1, -1, -1, -1, -1,
-1, 1, -1, 1, -1, 0, -1, 1, 0, -1, -1, 1, -1, -1, -1,
1, -1, 1, -1, 0, 1, 0, -1, 0, 0, 1, -1, 0, 1, 1, -1,
0, 1, -1, 0, -1, 1, 0, 0, -1, 0, 1, 0, -1, 1, 1, 0,
-1, 1, -1, -1, -1, 1, 0, -1, -1, 0, 1, -1, -1, 1, 1,
-1, -1, 1, -1, -1, 1, 1, 0, -1, 1, 0, 1, -1, 1, 1, 1,
-1, 1, 1, -1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0,
1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1,
0, 1, 1, 0, 1, -1, 0, 0, -1, 0, 1, 1, 0, 0, 0, 0, 1,
0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0,
0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, -1, -1, 1, 1, 1,
0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1, 0, 1, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, -1, 1,
-1, -1, 1, 1, 1, 0, -1, 1, 0, -1, 0, 0, 1, 1, 0, 1,
-1, 0, 1, 0, -1, 0, 1, 1, 1, 1, -1, 1, 1, -1, -1, 1,
1, 1, 1, 1, -1, 1, -1, -1, 1, -1, 1, 0, 1, 0, 0, -1,
0, 0, 0, 0, 1, 0, 0, 1, 0, 0, -1, 0, 0, 0, 1, 0, 1,
1, 0, -1, -1, 0, 0, 1, 1, 0, 1, 1, 0, -1, 1, 0, 0, -1,
0, 1, 1, 0, 0, 0, 0, -1, 0, 0, 0, 1, 0, 1, 0, 0, 0,
0, -1, 0, 0, 1, 1, 1, 0, 0, 0, -1, -1, 1, 0, 1, 1, 1,
0, 0, 0, -1, 1, -1, 1, 1, 1, 0, 1, -1, 0, -1, 0, 0,
1, 1, 0, 1, 1, 0, -1, 0, -1, 0, 1, 1, 1, 1, 1, -1, -1,
-1, -1, 1, 1, 1, 1, 1, 1, -1, 1, -1, 1, -1, 1, 1, 1,
0, -1, -1, 0, 1, 0, 0, 1, 1, 0, 1, -1, 0, -1, 0, 1,
0, 1, 1, 1, 1, -1, -1, -1, 1, 1, 1, 1, 1, 1, 1, -1,
-1, 1, 1, -1, -1, 0, 0, 0, 0, 0, 0, -26507, 0, -26509,
0
};

/*double floor(double x)
{
return (long)x;
}

double pow(double x, double y)
{
double a = y*log(x);
return exp(a);
}*/

int16_t tab_word2[16];

void pulcod_flaginit()
{
	pulcod_flag_1=0;
	pulcod_flag_2=1;
}

int sar_16(int x)
{
	return x >> 16;
}

double fmul_65536(int16_t x)
{
	return x*65536.0;
}

int16_t calc_0f811(int x)
{
	int a,d;
	a = x >> 15;
	d = x >> 8;
	a &= 1;
	d &= 1;
	a ^= d;
	return (a|(x+x));
}

int32_t convert_long(double real_arg1, int flag);

int satu_acc(double real)
{
 return (convert_long(real, 0) >> 16);	
}

void pulcod_datainit(void);

int pulcod_var_init(int16_t frequency);

int pulcodinibufsize(int16_t pulcod_size)
{
	int c = pulcod_size;
	if(c<24)return -1;
	if(c>64)return -1;
	
	if((c & 0x80000003)<0) //????
	{
		c--;
		c |= 0x0FFFFFFFC;
		c++;
		if(c!=0)return-1;
	}
	if((pulcod_size & 0x80000003)!=0)return -1;
	
	pulcod_buf_size2 = pulcod_size*2;
	pulcod_buf_size  = pulcod_size;
	
	return 0;
}

void pulcod_d_v_init(void)
{
	pulcod_datainit();
	pulcod_flaginit();
	pulcod_var_init(8000);
	pulcodinibufsize(36);
}

int nas_ced_pulcod2_init(int freq,int pulcod_size)
{
 pulcod_d_v_init();
 pulcod_var_init(freq);
 return pulcodinibufsize(pulcod_size);
}

double calc_fp_mulladd(int16_t x,int16_t v)
{
	double d;
	
	d = x;
	d *= v;
	d +=d;
	return d;
}

void cpy_word(const int16_t *in,int16_t *out,int16_t count)
{
	int i;
	if(count <= 0)return;
	for(i=0; i<count; i++)
		out[i]=in[i];
}

int calcul_cpy_data(int16_t *buf_in,int16_t *buf_out,int16_t flag);
int calcul_data_int2(int16_t *buf_in,int16_t *buf_out,int16_t count);

int proces_data_int(int16_t *buf_in,int16_t* buf_out,int16_t flag)
{
	int16_t buf_tmp[10];
	calcul_cpy_data(buf_in, buf_tmp, flag);
	calcul_data_int2(buf_tmp,buf_out,10);
	return 0;
}

int mpy_16_16_sft1(int16_t a,int16_t b,int flag)
{
	double d;
	d = a;
	d *= b;
	d += d;
	return convert_long(d, flag);
}

int add_buf_in_front(int16_t *in_buf,int16_t *out_buf)
{
	int i;
	int16_t* out_ptr = out_buf+30;
	for(i=0; i<3; i++)
	{
		cpy_word(out_ptr-10,out_ptr,10); 
		out_ptr -=10;
	}
	cpy_word(in_buf,out_buf,10);
	return 0;
}

double calcul_float2(double double_arg,int flag);

double macss_16_16_sft1(double double_x,int16_t int_y,int16_t z_word,int flag)
{
	double d;
	d = int_y;
	d *= z_word;
	d += d;
	d = double_x - d;
	return calcul_float2(d,flag);
}

void do_buf_cpy(void)
{
	int i;
	for(i=0; i<4; i++)
	{
	 cpy_word(buf_const10,buf_word_x4+10*i,10);
	}
	flag_1 = 0;
	cpy_word(buf_const10, tab_word2, 10);
}

 int process_buf(int16_t *in_buf,int in_start);

void proces_copy(int in_start,int16_t *in_buf,int16_t *out_buf)
{
	int i;
	process_buf(in_buf, in_start);
	if(pulcod_buf_size<=0) return;
	for(i=0; i< pulcod_buf_size; i++)
		out_buf[i]=in_buf[i+261];
}

int to_16bit(double fval)
{
	if(fval>=2.147450879e9)return 32767;
	if(fval<-2.14745088e9) return -32768;
	return ((((long)floor(fval))+32768)>>16);
}

int calcul_long2(int16_t *in,int16_t *out_buf);

int calcul_2(int16_t *inbuf1,int16_t *inbuf2,int16_t *out_buf)
{
	int i;
	int16_t tmp[10];
	for(i=0; i<10; i++)
	{
		tmp[i] = (inbuf1[i]>>1)+(inbuf2[i]>>1);
	}
	calcul_long2(tmp,out_buf);
	calcul_long2(inbuf2,out_buf+11);
	return 0;
}

int calcul_data_int3(int16_t *buf_in,int16_t *inbuf1,int16_t *out_bufx)
{
	int16_t tmp_buf1[10], tmpout_buf[22];
	proces_data_int(buf_in,tmp_buf1,0);
	calcul_2(inbuf1,tmp_buf1,tmpout_buf);
	memcpy(out_bufx,tmpout_buf,22);
	memcpy(out_bufx+11,tmpout_buf+11,22);
	memcpy(inbuf1,tmp_buf1,20);
	return 0;
}

int32_t sft_32(int x_int,int16_t y,int flag)
{
	int64_t l;
	int32_t ll;
	int a;
	double real_var1;
    double real_var2;
	l = ll = y;
	ll ^= (l >> 32); ///abs ???
	ll -= (l >> 32); ///
	a = 1 << (ll & 0xff);
	if(y<0)
	{
	 real_var2 = x_int/a;
	 real_var1 = floor(real_var2);	
	}else
	 real_var1 = x_int*a;
	
	return convert_long(real_var1,flag);
}

int check_frame(int16_t *arg_pulcod_buf);
int pulcod_sub2(void);

int pulcod(unsigned char *in,int16_t *out)
{
	int i;
	int ret;
	for(i=0;i<9;i++) 
		pulcod_frame[i]=in[i];
	ret = check_frame(pulcod_buf_2);
	if(!ret)
	{
		pulcod_sub2();
	}
	if(ret == 1)return 0;
	if(pulcod_buf_size2<=0)return pulcod_buf_size2;
	for(i=0;i<pulcod_buf_size2;i++)
		out[i]=pulcod_buf_2[i];
	return pulcod_buf_size2;
}

double calcul_pow(double double_arg,int16_t x,int boolflag)
{
	double d;
	if(boolflag!=-1)return double_arg;
	if(x>=0)
	{
		d = double_arg*pow(2.0,x);
	}else
	{
		d = double_arg/pow(2.0,fabs(x));
	}
	return floor(calcul_float2(d,-1));
}

int calcul_data_int2(int16_t *buf_in,int16_t *buf_out,int16_t count)
{
	int i;
	if(count<=0)return 0;
	for(i=0;i<count;i++)
	{
		int a, b, c;
		c = buf_in[i];
		a = c*9; // a = 9*c
		a <<=4;  // a = 144*c
		a += c;  // a = 145*c
		a <<=3;  // a = 1160*c
		a -=c;   // a = 1159*c
		a = a*9; // a = 10431*c
		a <<= 1; // a = 20862*c
		a -= c;  // a = 20861*c
		a <<=1;  // a = 41722*c
		a >>= 16;
		c = (int16_t)a;
		a &= 0xff;
		c >>=8;
		if(c>63)c=63;
		b = table_2[c];
		b*=a;
		b <<=1;
		b >>=13;
		b+=table_1[c];
		buf_out[i]=b;
	}
	return 0;
}

int pulcod_var_init(int16_t frequency)
{
	if(frequency>=14000)
	{
		pulcod_var1 = 40;
	}
	else
	if(frequency>=11000)
	{
		pulcod_var1 = 30;
	}
	else
	if(frequency>=9500)
	{
		pulcod_var1 = 25;
	}
	else
	if(frequency>=7000)
	{
		pulcod_var1 = 20;
	}
	else
	{
		pulcod_var1 = 15;
	}
	return 0;
}

int nas_ced(uint8_t *in,int16_t *out,int mode,int bit_size)
{
	int size=0;
	int i;
	if(mode==2)
	{
		size = pulcod(in,out);
		if(bit_size==8)
		{
			for(i=0;i<size;i++)
				out[i] >>= 8;
		}
	}else
		return -1;
	return size;
}

int calcul_powerof2(double real_x,int16_t *out_word_ptr)
{
	long x;
	int ret=0;
	if((real_x>=2.147450879e9) | (real_x<-2.14745088e9))
	{
	 *out_word_ptr = 0;
	 return 0;
	}
	x = floor(real_x);
	if(!x)
	{
		*out_word_ptr = -31;
		return 0;
	}
	if(x<0)
	{
		while(x>=-0x40000000)
		{
			ret--;
			x <<= 1;
		}
		*out_word_ptr = ret;
		return x;
	}
	while(x<0x40000000)
	{
		ret--;
		x <<= 1;
	}
	*out_word_ptr = ret;
	return x;
}

int add_offset(int16_t *buf_word,int16_t offset)
{
	int i;
	for(i=0;i<9;i++)
	{
		int a, d, e, s;
		d = buf_word[i];
		e = buf_word[i+1];
		s = d;
		a = d - e;
		a += offset;
		a >>= 1;
		if(a>0)
		{
			s-=a;
			if(s>32767)
				d = 32767;
			else
			if(s<-32768)
				d = -32768;
			else
				d-=a;
			buf_word[i]=d;
			
			s = buf_word[i+1];
			s+=a;
			if(s>32767)
				a = 32767;
			else
			if(s<-32768)
				a = -32768;
			else
				a = s;
			buf_word[i+1]=a;
		}
		
	}
	return 0;
}

int buf_proces_int(int16_t *ptr_word)
{
	int i;
	for(i=0;i<9;i++)
	{
		int c,d;
		d = ptr_word[i];
		c = ptr_word[i+1];
		if(c<d)
		{
			ptr_word[i]  =c;
			ptr_word[i+1]=d;
		}
	}
	
	if(ptr_word[0]<40)
		ptr_word[0]=40;
	
	for(i=0;i<9;i++)
	{
		int a,b,d;
		a = d = ptr_word[i];
		b = ptr_word[i+1];
		b -= a;
		if(b<321)
		{
			a+=321;
			if(a>32767)
				a=32767;
			else
			if(a<-32768)
				a=-32768;
			else
			{
				d+= 321;
				a = d;
			}
			ptr_word[i+1] = a;
		}
	}
	if(ptr_word[9]>25681)
		ptr_word[9]=25681;
	return 0;
}

int magnitude(int16_t *buf_word,int16_t *outbuf_word3,const int16_t *buf_word5,int16_t *buf_word2,const int16_t *buf_word4)
{
	int i, j;
	for(i=0;i<10;i++)
	{
		int c,d,a;
		double dd;
		c = buf_word[i];
		d = buf_word4[i];
		c *= d;
		dd = c;
		dd += c;
		for(j=0;j<4;j++)
		{
			int b,p;
			b = buf_word5[j*10+i];
			p = buf_word2[j*10+i];
			dd += 2*b*p;
		}
		if(dd>2.147483647e9)
			a = 0x7FFFFFFF;
		else
		if(dd<-2.147483648e9)
			a = 0x80000000;
		else
			a = dd;
		a >>=16;
		outbuf_word3[i]=a;
	}
	return 0;
}

int word_calcul(int16_t *wptr_in,int16_t *wptr_out,int16_t *wptr_out1,int16_t *wptr_ptr,int16_t *wptr_in2)
{
	int i;
	
	*wptr_out = 4096;
	*wptr_out1 = 4096;
	
	for(i=0;i<10;i++)
	{
	 int64_t a;
	 int c;
	 a = wptr_ptr[i];
	 c = wptr_in[i+1];
	 a *= c;
	 a *= 2;
	 if(a > 2147483647) 
	 {
	     a = 2147483647;
	 }else
	 if(a < (-2147483647 - 1))
	 {
	    a =  (-2147483647 - 1);
	 }
	 a >>=16;	
	 wptr_out[i+1] = a;
	 
	 a = wptr_in2[i];
	 c = wptr_in[i+1];
	 a *=c;
	 a *=2;
	 if(a > 2147483647)
	 {
	     a = 2147483647;
	 }else
	 if(a < (-2147483647 - 1))
	 {
	    a =  (-2147483647 - 1);
	 }
	 a >>=16;
	 wptr_out1[i+1]=a;
	 
	}
	return 0;
}

int calcul_data_int(const int16_t *buf_word_in,const int16_t *buf_word_in2,int16_t pos1,int16_t pos2,int16_t pos3,const int16_t *buf_word5,int16_t *in_buf,int16_t *outbuf_word3,const int16_t *buf_word4);
int proces_x(int16_t *buf_word_in,int16_t *out_word_buf,const int16_t *buf_word_in2,int16_t *buf_word_in3,const int16_t *buf_word_out);

int calcul_cpy_data(int16_t *buf_in,int16_t *buf_out,int16_t flag)
{
	int16_t out_buf[16];
	if(flag)
	{
		int a, c;
		cpy_word(tab_word2,buf_out,10);
		a = flag_1;
		c = 5*a;
		a = 5*a;
		a <<= 4;
		proces_x(tab_word2,out_buf,tab_int4+a/2,buf_word_x4,buf_const5+c*2);
		add_buf_in_front(out_buf,buf_word_x4);
	}
	else
	{
		int a,c,d,s,di;
		c = buf_in[0];
		a = buf_in[1];
		d = c;
		c &= 0x7f;
		d >>= 7;
		d &= 1;
		s = d;
		d = (int16_t)s;
		d *= 5;
		di = d;
		
		//
		d = a;
		d &= 0x1f;
		a >>= 5;
		a &= 0x1f;
		calcul_data_int(buf_const_in, buf_const_in2,c,a,d,tab_int4+di*8,buf_word_x4,buf_out,buf_const4+di*2);
		cpy_word(buf_out,tab_word2,10);
		flag_1 = s;
	}
	return 0;
}

double calcul_float2(double double_arg,int flag)
{
	var_int_calcul = 0;
	var_doubl_calcul = 0;
	if(double_arg>5.49755813887e11)
	{
		if(flag == 1)
		{
			return 5.49755813887e11;
		}
		else
		if(flag == 0)
		{
		 return 5.49755813887e11;	
		}else
		if(flag == -1)
		{
			var_int_calcul = 1;
			var_doubl_calcul = double_arg;
			return double_arg;
		}else
		{
			var_int_calcul = 1;
			var_doubl_calcul = double_arg;
			return double_arg;
		}
	}
	else
	if(double_arg<-5.49755813888e11)
	{
		if(flag == 1)
		{
			return -5.49755813888e11;
		}else
		if(flag == 0)
		{
			return -5.49755813888e11;
		}
		else
		if(flag == -1)
		{
			var_int_calcul = 1;
			var_doubl_calcul = double_arg;
			return double_arg;
		}else
		{
			var_int_calcul = 1;
			var_doubl_calcul = double_arg;
			return double_arg;
		}
	}
	else
	 return double_arg;
}

int proces_x(int16_t *buf_word_in,int16_t *out_word_buf,const int16_t *buf_word_in2,int16_t *buf_word_in3,const int16_t *buf_word_out)
{
	int i,j;
	double double_x;
	for(i=0;i<10;i++)
	{
		double_x = fmul_65536(buf_word_in[i]);
		for(j=0;j<4;j++)
		{
			double_x = macss_16_16_sft1(double_x,buf_word_in3[i+10*j],buf_word_in2[i+10*j],1);
		}
		int a = satu_acc(double_x);
		a = mpy_16_16_sft1(a,buf_word_out[i],1);
		a = sft_32(a,3,1);
		a = sar_16(a);
		out_word_buf[i]=a;
	}
	return 0;
}

int calcul_bufs(int16_t *in,int start,int16_t *buf)
{
	int i;
	if(pulcod_buf_size<=0)return 0;
	
	for(i=0;i<pulcod_buf_size;i++)
	{
		int64_t a;
		int b,c,d;
		a = in[261+i-start];
		c = a*5; //a*5
		c = c*9; //a*45
		c = c*2+a; //a*91
		d = c*9; //a*819
		a += d*4;//a*3277
		a <<=2; //a*13108
		a = buf[i]*65536L + a;
		if(a>2147450879)
			b = 32767;
		else
		if(a<-2147450880)
			b = -32768;
		else
		{
			a+=32768;
        	a>>=16;
        	b = a;
		}
		buf[i]=b;
	}
	return 0;
}

 int32_t convert_long(double real_arg1,int flag)
 {
     var_int_calcul = 0;
     var_doubl_calcul = 0;
     if(real_arg1>2.147483647e9)
     {
         if(flag == 1)
         {
             return 2.147483647e9;
         }
         else
         if(flag == 0)
         {
             return 2.147483647e9;
         }
         else
         if(flag == -1)
         {
             var_int_calcul = 1;
             var_doubl_calcul = real_arg1;
             return var_doubl_calcul;
         }else
         {
             var_int_calcul = 1;
             var_doubl_calcul = real_arg1;
             return var_doubl_calcul;
         }
     }
     else
     if(real_arg1<-2.147483648e9)
     {
         if(flag == 1)
         {
             return -2.147483648e9;
         }
         else
         if(flag == 0)
         {
             return -2.147483648e9;
         }
         else
         if(flag == -1)
         {
             var_int_calcul = 1;
             var_doubl_calcul = real_arg1;
             return var_doubl_calcul;
         }else
         {
             var_int_calcul = 1;
             var_doubl_calcul = real_arg1;
             return var_doubl_calcul;
         }
     }
    return real_arg1;
 }

int calcul_coeff(int ctable_index,int16_t *buf_word,int16_t *out_word_ptr,int16_t *out_word_ptr2)
{
	int64_t a;
	int b;
	int16_t c;
	a = *buf_word;
	a *= 0xcccc;
	
	if(a>2147450879L)
		b = 32767;
	else
	if(a<-2147450880L)
		b = -32768;
	else
	{
		a+=32768;
        a>>=16;
        b = a;
	}
	
	b+=49;
	
	c = const_table[ctable_index*7];
	out_word_ptr[0]=c;
	a = const_table[ctable_index*7+1];
	a *= b;
	a *= 8;
	
	if(a>2147450879L)
		b = 32767;
	else
	if(a<-2147450880L)
		b = -32768;
	else
	{
		a+=32768;
        a>>=16;
        b = a;
	}
	*out_word_ptr2=b;
	*buf_word=b;
	return 0;
}

int calcul_64b(int16_t *buf_in1,const int16_t *ptr_dword1,int16_t *ptr_word,int16_t val_word,int16_t *buf_out1)
{
	int i;
	if(pulcod_buf_size<=0)return 0;
	
	for(i=0;i<pulcod_buf_size;i++)
	{
		int64_t a;
		int b;
		int c;
		int d;
		b = buf_in1[i];
		c = *ptr_dword1;
		a = b;
		a *=c;
		a *=2;
		
		c = *ptr_word;
		d  = ptr_dword1[1];
		d = c*d;
		d <<= 1;
		*ptr_word = b;
		a+=d;
		if(val_word<0)
		{
		 a >>= -val_word;
		}else
		{
		 a <<= val_word;
		}
		if(a>2147450879L)
			b = 32767;
		else
		if(a<-2147450880L)
			b = -32768;
		else
		{
			a+=32768;
        	a>>=16;
        	b = a;
		}
 		buf_out1[i]=b;
	}
	return 0;
}

int process_buf2(int *wptr,int *buf_word_in2,int stab_pos,int16_t *buf_word_out1,int16_t *buf_word1,int flag0)
{
	if(flag0 == 0)
	{
		int d;
		d = wptr[0];
		d <<= 2;
		buf_word_out1[0]=d;
		
		d =sign_tab[stab_pos*4];
		buf_word1[0]=d;
		
		d = wptr[1];
		d <<= 2;
		d++;
		buf_word_out1[2]=d;
		
		d = sign_tab[stab_pos*4+2];
		buf_word1[2]=d;
		
		d = wptr[0];
		d = d*4 + 18;
		if(d<pulcod_buf_size)
		{
			d = wptr[0];
			d <<=2;
			d += 18;
			buf_word_out1[1]=d;
		}else
		{
			d = wptr[0];
			d <<= 2;
			d += 18;
			d -=pulcod_buf_size;
			buf_word_out1[1]=d;
		}
		
		d = sign_tab[stab_pos*4+1];
		buf_word1[1]=d;
		
		d = wptr[1];
		d = d*4 + 19;
		
		if(d<pulcod_buf_size)
		{
			d = wptr[1];
			d <<= 2;
		}
		else
		{
			d = wptr[1];
			d <<= 2;
			d -= pulcod_buf_size;
		}
		d+= 19;
		buf_word_out1[3]=d;
		
		d = sign_tab[stab_pos*4+3];
		buf_word1[3]=d;
		
		
	}else
	{
		int a;
		buf_word_out1[0] = 0;
		buf_word1[0] = 0;
		buf_word_out1[1] = 0;
		buf_word1[1] = 0;
		a = wptr[0];
		a <<= 1;
		buf_word_out1[2]=a;
		a = buf_word_in2[0];
		buf_word1[2]=a;
		a = wptr[1];
		a <<= 1;
		a++;
		buf_word_out1[3]=a;
		a = buf_word_in2[1];
		buf_word1[3]=a;
	}
	return 0;
}

int decode_16_32(int16_t *in,int *out);

int calcul_long2(int16_t *in,int16_t *out_buf)
{
	int i;
	int out[6];
	int out2[6];
	decode_16_32(in,out);
	decode_16_32(in+1,out2);
	for(i=0;i<5;i++)
	{
		int a,d;
		d = out[4-i];
		a = out[5-i];
		d+=a;
		if(d>2.147483647e9)
			a = 2147483647;
		else
		if(d<-2.147483648e9)
			a = (-2147483647 - 1);
		else
			a = d;
		
		out[5-i]=a;
		
		d = out2[4-i];
		a = out2[5-i];
		a-=d;
		if(a>2.147483647e9)
			a = 2147483647;
		else
		if(a<-2.147483648e9)
			a = (-2147483647 - 1);
		out2[5-i]=a;
		
	}
	
	out_buf[0]=4096;
	
	for(i=0;i<5;i++)
	{
		int b,p;
		b = out2[i+1];
		p = out[i+1];
		b+=p;
		b>>=12;
		b++;
		b>>=1;
		out_buf[i+1]=b;
		
		b = out[i+1];
		p = out2[i+1];
		b-=p;
		b>>=12;
		b++;
		b>>=1;
		out_buf[10-i]=b;
	}
	return 0;
}

int process_buf(int16_t *in_buf,int in_start)
{
	int i,j;
	int16_t *buf_ptr = in_buf + 261 - in_start;
	if(pulcod_buf_size<=0)return 0;
	for(i=0;i<pulcod_buf_size;i++)
	{
		int64_t l;
		l = 0;
		for(j=0;j<10;j++)
		{
			int a,d;
			a = tab_const_xx[j*3];
			d = buf_ptr[-j];
			l+= 2*a*d;
			a = tab_const_xx[(j+1)*3];
			d = buf_ptr[j+1];
			l+= 2*a*d;
		}
		buf_ptr++;
		
		if(l>2147450879L)
			l = 32767;
		else
		if(l<-2147450880L)
			l = -32768;
		else
		{
			l+=32768;
        	l>>=16;
		}
		in_buf[261+i]=l;
	}
	return 0;
}

void pulcod_datainit2(void)
{
	int i;
	double real;
	for(i=0;i<9;i++)
	 tab_dword1_0[i]=0;
	memcpy(tab_word_0,data_const5,20);
	memset(tab_tmp_in,0,650);
	do_buf_cpy();
	for(i=0;i<9;i++)
	 tab_dword1[i]=0;
	memset(tab_word,0,650);
	for(i=0;i<9;i++)
	 tab_dword2[i]=0;
	tab_int_16384[0]=16384;
	tab_int_22938[0] = 22938;
	tab_int1[0] = 21299;
	var_word_491 = 491;
	for(i=0;i<9;i++)
	{
		real = calc_fp_mulladd(tab_int_22938[i],22938);
		tab_int_22938[i+1]=satu_acc(real);
		real = calc_fp_mulladd(tab_int1[i],21299);
		tab_int1[i+1]=satu_acc(real);
	}
}

int calcul_64b_2(int16_t *buf_word_in,int16_t *buf_word_in1,int16_t *buf_word_io,int16_t nr_shl,int16_t *buf_word_out)
{
	int i,j;
	if(pulcod_buf_size<=0)return 0;
	for(i=0;i<pulcod_buf_size;i++)
	{
		int64_t l;
		l = buf_word_in[i];
		l *=buf_word_in1[0];
		l *=2;
		for(j=0;j<10;j++)
		{
			int  a = buf_word_in1[10-j];
			a*= buf_word_io[9-j];
			a <<=1;
			l-=a;
		}
		for(j=0;j<9;j++)
		{
			int a;
			a = buf_word_io[8-j];
			buf_word_io[9-j]=a;
		}
		
		if(nr_shl<0)
		{
		 l >>= -nr_shl;
		}else
		l<<=nr_shl;
		
		if(l>2147450879L)
			l = 32767;
		else
		if(l<-2147450880L)
			l = -32768;
		else
		{
			l+=32768;
        	l>>=16;
		}
		buf_word_out[i]=l;
		buf_word_io[0]=l;
	}
	return 0;
}

int calcul_data_int(const int16_t *buf_word_in,const int16_t *buf_word_in2,int16_t pos1,int16_t pos2,int16_t pos3,const int16_t *buf_word5,int16_t *in_buf,int16_t *outbuf_word3,const int16_t *buf_word4)
{
	int i;
	int16_t tmp_buf[10];
	for(i=0;i<5;i++)//ok
	{
		int a,d;
		a = buf_word_in[pos1*10+i];
		d = buf_word_in2[pos2*10+i];
		d +=a;
		if(d>32767)
			d = 32767;
		else
		if(d<-32768)
			d = -32768;
		tmp_buf[i]=d;
	}
	for(i=0;i<5;i++)//ok
	{
		int a,d;
		a = buf_word_in[pos1*10+i+5];
		d = buf_word_in2[pos3*10+i+5];
		d +=a;
		if(d>32767)
			d = 32767;
		else
		if(d<-32768)
			d = -32768;
		tmp_buf[i+5]=d;
	}
	add_offset(tmp_buf,10);
	add_offset(tmp_buf,5);
	magnitude(tmp_buf,outbuf_word3,buf_word5,in_buf,buf_word4);
	add_buf_in_front(tmp_buf,in_buf);
	buf_proces_int(outbuf_word3);
	return 0;
}
int word_calcul2(int16_t *buf_word_in,int16_t *buf_word_in2,int16_t *buf_word_in3,int16_t nr_shl,int16_t *buf_word_out)
{
	int i,j;
	if(pulcod_buf_size<=0)return 0;
	for(i=0;i<pulcod_buf_size;i++)
	{
		int64_t l;
		l = buf_word_in[i];
		l *=buf_word_in2[0];
		l *=2;
		for(j=0;j<10;j++)
		{
			int  a = buf_word_in2[10-j];
			a*= buf_word_in3[9-j];
			a <<=1;
			l+=a;
		}
		for(j=0;j<9;j++)
		{
			int a;
			a = buf_word_in3[8-j];
			buf_word_in3[9-j]=a;
		}
		
		buf_word_in3[0]=buf_word_in[i];
		
		if(nr_shl<0)
		{
		 l >>= -nr_shl;
		}
		else
		 l<<=nr_shl;
		
		if(l>2147450879L)
			l = 32767;
		else
		if(l<-2147450880L)
			l = -32768;
		else
		{
			l+=32768;
        	l>>=16;
		}
		buf_word_out[i]=l;
	}
	return 0;
}

int calc_int(int16_t *buf_word_in,int16_t *buf_word_in2,int16_t nr_shl,int16_t *buf_word_io)
{
	int i,j;
	int16_t tmp_buf[10]={0};
	if(pulcod_buf_size<=0)return 0;
	for(i=0;i<pulcod_buf_size;i++)
	{
		int64_t l;
		l = buf_word_in[i];
		l *=buf_word_in2[0];
		l *=2;
		for(j=0;j<10;j++)
		{
			int  a = buf_word_in2[10-j];
			a*= tmp_buf[9-j];
			a <<=1;
			l-=a;
		}
		for(j=0;j<9;j++)
		{
			int a;
			a = tmp_buf[8-j];
			tmp_buf[9-j]=a;
		}
		
		if(nr_shl<0)
		{
		 l >>= -nr_shl;
		}
		else
		 l<<=nr_shl;
		
		if(l>2147450879L)
			l = 32767;
		else
		if(l<-2147450880L)
			l = -32768;
		else
		{
			l+=32768;
        	l>>=16;
		}
		buf_word_io[i]=l;
		tmp_buf[0]=l;
	}
return 0;
}

int parse_frame(int16_t *ptr_2xword_out,int *buf_dword_out2,int *buf_dword_out3,int *buf_dword_out4,int *buf_dword_out6,int *buf_dword_out5,int *buf_dword_out,int16_t *frame_in)
{
	int a,b,c,d,s,di,p;
 	c = frame_in[0];
	d = frame_in[1];
	c &=0x7f;
	c <<=1;
	d >>=7;
	d &= 1;
	ptr_2xword_out[0]=c | d;
	
	c = frame_in[2];
	d = frame_in[1];
	c >>=5;
	c &= 7;
	d &= 0x7f;
	d <<=3;
	ptr_2xword_out[1]=c | d;
	
	d = frame_in[2];
	c = frame_in[3];
	s = c;
	d &=0x1f;
	s >>=5;
	c &=0x1f;
	s &=7;
	d <<=3;
	b = c;
	d |=s;
	c = frame_in[5];
	di= frame_in[6];
	p=d;
	s=c;
	d = frame_in[4];
	s >>=2;
	d <<=6;
	s &=0x3f;
	c &=3;
	d |=s;
	s = frame_in[7];
	c <<=8;
	c |=di;
	di = s;
	di>>=6;
	c <<=2;
	di&=3;
	s &=0x3f;
	c |=di;
	di = c;
	c = frame_in[8];
	c >>=7;
	c &=1;
	s <<=1;
	c|=s;
	buf_dword_out[0]=c;
	c = frame_in[8];
	c &=0x7f;
	buf_dword_out[1]=c;
	buf_dword_out2[0]=p;
	buf_dword_out3[0]=0;
	a = buf_dword_out2[0];
	s = pulcod_var1;
	a-=5;
	if(a<=s)
	{
		a = s;
	}
	s |=0xFFFFFFFF;
	if(b==0x1f)
	{
		b = s;
	}
	a+=b;
	buf_dword_out2[1]=a;
	c = d;
	buf_dword_out3[1]=0;
	c &=0xf;
	buf_dword_out4[0]=c;
	c = d;
	c >>=4;
	c &=0xf;
	buf_dword_out4[1]=c;
	d >>=8;
	d &=0x3f;
	buf_dword_out5[0]=d;
	c = d = di;
	c >>=5;
	c &=0x1f;
	d &=0x1f;
	buf_dword_out4[2]=d;
	buf_dword_out4[3]=c;
	a = di;
	c = 1;
	a >>=10;
	di>>=11;
	a &=c;
	di&=c;
	if(a>0)
	{
		buf_dword_out6[2]=c;	
	}else
	{
		buf_dword_out6[2]=s;	
	}
	
	if(di>0)
	{
		buf_dword_out6[3]=c;	
	}else
	{
		buf_dword_out6[3]=s;	
	}
return 0;
}

int check_frame(int16_t *buf_word_out)
{
	int i,j;
	double fval;
	int16_t buf_word_tmp[128];
	if(pulcod_frame[0]!=240)return 0;
	if(pulcod_flag_2==1)
	{
		pulcod_flag_2=0;
		pulcod_flag_1=(pulcod_frame[1]&0xff)|pulcod_frame[2];
	}
	if(pulcod_flag_1 == 0)
	{
		pulcod_datainit2();
		pulcod_flag_2 = 1;
		return 1;
	}
	if(pulcod_buf_size2>0)
	{
		memset(buf_word_tmp,0,pulcod_buf_size*4+pulcod_buf_size*4);
	}
	for(i=0;i<4;i++)
	{
		int a = var_word_3;
		int di=0;
		int si;
		for(j=0;j<6;j++)
		{
			int d,c;
			d = a = calc_0f811(a);
			d &=1;
			c = 2*di;
			d |=c;
			var_word_3 = a;
			di = d;
		}
		si = 0;
		for(j=0;j<16;j++)
		{
			int d,c;
			c = a = calc_0f811(a);
			c &=1;
			d = 2*si;
			c |=d;
			var_word_3 = a;
			si = c;
		}
		fval = calc_fp_mulladd(si,var_word_491);
		a = to_16bit(fval);
		buf_word_tmp[di]=a;
	}
	calc_int(buf_word_tmp,tab_tmp_out,3,buf_word_out);
	calc_int(buf_word_tmp+pulcod_buf_size,buf_word_tmp,3,buf_word_out+pulcod_buf_size);
	pulcod_flag_2--;
	return -1;
}

void pulcod_datainit(void)
{
	int i;
	memset(pulcod_buf_2,0,64*4);
	memset(tab_dword1_0,0,20);
	memcpy(tab_word_0,data_const5,20);
	memset(tab_tmp_in,0,650);
	do_buf_cpy();
	memset(tab_dword1,0,20);
	memset(tab_dword2,0,20);
	var_word_491 = 491;
	pulcod_buf_end=0;
	if(pulcod_buf_size+0x105>0)
	{
		memset(tab_word,0,2*(pulcod_buf_size+0x105));
	}
	tab_int_16384[0]=16384;
	tab_int_22938[0]= 22938;
	tab_int1[0]= 21299;
	for(i=0;i<9;i++)
	{
		tab_int_22938[i+1] = satu_acc(calc_fp_mulladd(tab_int_22938[i],22938));
		tab_int1[i+1] = satu_acc(calc_fp_mulladd(tab_int1[i],21299));
	}
	calcul_long2(tab_word_0,tab_tmp_out);
	calcul_long2(tab_word_0,tab_tmp_out+11);
	var_word_3=3;
}

int decode_16_32(int16_t *in,int *out)
{
	int a,b,d;
	int i,j;
	int val;
	double realnum;
	*out = 16777216;
	out++;
	a = in[0];
	a = -a;
	a <<= 9;
	realnum = a;
	realnum +=realnum;
	if(realnum>2.147483647e9)
		a = 2147483647;
	else
	if(realnum<-2.147483648e9)
		a = (-2147483647 - 1);
	else
		a = realnum;
	*out=a;
	out++;
	b = 2;
	a = b;
	val = b;
	for(i=2;i<=5;i++)
	{
		int c = *(out-2);
		*out=c;
		
		if(b>1)
		{
			int aa;
			a--;
			for(j=0;j<a;j++)
			{
				int d;
				double fvar;
				d = in[(i-1)*2];
				fvar = *(out-1);
				fvar *= d;
				fvar += fvar;
				fvar = calcul_pow(fvar,-15,-1);
				realnum = *(out-2);
				realnum += *out;
				realnum -=fvar;
				if(realnum>2.147483647e9)
					aa = 2147483647;
				else
				if(realnum<-2.147483648e9)
					aa = (-2147483647 - 1);
				else
					aa = realnum;
				*out = aa;
				out--;
			}
			d = in[(i-1)*2];
			d <<=9;
			realnum = d;
			realnum+=realnum;
			realnum= *out - realnum;
			if(realnum>2.147483647e9)
				aa = 2147483647;
			else
			if(realnum<-2.147483648e9)
				aa = (-2147483647 - 1);
			else
				aa = realnum;
			*out = aa;
			b++;
			out = out + val;
			a = val;
			a++;
			val = a; 
		}
		
	}
return 0;
}

#define abs(x) (((x)<0)?-(x):(x))

int calul_bufs(int16_t *buf_word_in,int16_t *wptr_in,int16_t *buf_word_io,int16_t *buf_word_in3,int16_t *buf_dword,int16_t *in,int16_t *wptr_ptr,int16_t *wptr_in2,int start)
{
	int i;
	int16_t buf_word_in1[12];
	int16_t buf_word_in2[12];
	int16_t buf_word_temp1[64];
	word_calcul(wptr_in,buf_word_in1,buf_word_in2,wptr_ptr,wptr_in2);
	word_calcul2(buf_word_in,buf_word_in2,buf_word_in3,3,buf_dword);
	if(pulcod_buf_size>0)
	{
		for(i=0;i<pulcod_buf_size;i++)
		{
			in[i+261]= buf_dword[i];
		}
	}
	calcul_bufs(in,start,buf_dword);
	calcul_64b_2(buf_dword,buf_word_in1,buf_word_io,3,buf_dword);
	for(i=0;i<261;i++)
	{
		in[i]=in[pulcod_buf_size+i];
	}
	memcpy(buf_word_temp1,buf_word_in2,5*4+2);
	if(pulcod_buf_size>11)
	{
		memset(buf_word_temp1+11,0,(pulcod_buf_size-11)*2);
	}
	calc_int(buf_word_temp1,buf_word_in1,3,buf_word_temp1);
	int64_t a=0;
	for(i=0;i<20;i++)
	{
		a += abs(buf_word_temp1[i]);
	}
	if(a < 4096)return 0;
	
	a = 134217728/a;
	if(pulcod_buf_size<0)return 0;
	
	for(i=0;i<pulcod_buf_size;i++)
	{
		int64_t x;
		
		x=buf_dword[i];
		x*=a;
		x*=2;
		if(x>2147450879L)
			x = 32767;
		else
		if(x<-2147450880L)
			x = -32768;
		else
		{
			x+=32768;
        	x>>=16;
		}
		buf_dword[i]=x;
	}
return 0;
}

void calcul_process(int16_t* buf_word_in2,int16_t *ptr_word_io,int16_t *buf_word_in1)
{
	double real_x = 0.0;
	int i;
	int16_t powerof2;
	double realnum;
	int a,b,aa;
	
	if(pulcod_buf_size>0)
	{
		for(i=0;i<pulcod_buf_size;i++)
		{
			real_x += abs(buf_word_in2[i]);
		}
	}
	
	calcul_powerof2(real_x,&powerof2);
	
	if(powerof2<0)
		powerof2+=3;
	
	realnum = calcul_pow(real_x,-powerof2,-1);
	
	if(realnum>2.147483647e9)
		a = 2147483647;
	else
	if(realnum<-2.147483648e9)
		a = (-2147483647 - 1);
	else
		a = realnum;
	
	a >>=16;
	
	real_x = 0.0;
	
	if(pulcod_buf_size>0)
	{
		for(i=0;i<pulcod_buf_size;i++)
		{
			real_x += abs(buf_word_in1[i]);
		}
	}	
	
	realnum = calcul_pow(real_x,-powerof2,-1);
	
	if(realnum>2.147483647e9)
		b = 2147483647;
	else
	if(realnum<-2.147483648e9)
		b = (-2147483647 - 1);
	else
		b = realnum;
	
	b >>=16;
	
	if(b!=0)
	{
		a >>=2;
		if(b>a)
		{
			aa = a*3.2768e4/b; ///?????
		}
		else
			aa = 32767;
		aa <<=1;
		if(aa>32767)
			aa = 32767;
		else
		if(aa<-32768)
			aa = -32768;
	}else
		aa=0;
	
	if(pulcod_buf_size<=0)return;
	
	int64_t a1, a2;
	int d;
	
	d = 5*aa;
	aa = aa + d*8;
	aa *=5;
	aa <<=2;
	a1 = aa; 
	a2 = ptr_word_io[0];
	for(i=0;i<pulcod_buf_size;i++)
	{
		int64_t x;
		a2 *= 64716;
		a2 += a1;
		if(a2>2147483647)
			a2 = 2147483647;
		else
		if(a2<(-2147483647 - 1))
			a2 = (-2147483647 - 1);
		
		a2 >>=16;
		
		x = 4*buf_word_in1[i]*a2;
		
		if(x>2147450879L)
			x = 32767;
		else
		if(x<-2147450880L)
			x = -32768;
		else
		{
			x+=32768;
        	x>>=16;
		}
		buf_word_in1[i]=x;
	}
	ptr_word_io[0]=a2;
}

int pulcod_sub2(void)
{
	int16_t a[2];
	int16_t buf_word1[4];
	int in_start[2];
	int c[2]; 
	int d[4]; 
	int e[4]; 
	int f[2]; 
	int16_t *buf_word_in1;
	int16_t out_word_ptr2;
	int16_t out_bufx[22];
	int16_t buf_dword[64];
	int16_t buf_local_in2[64];
	int16_t buf_word_in[64];
	int16_t out_buf[64];
	int16_t buf_word_out1[4];
	int16_t int_var;
	int const_table_index[2];
	int i,j;
	buf_word_in1 = out_bufx;
	parse_frame(a,in_start,c,d,e,f,const_table_index,pulcod_frame);
	calcul_data_int3(a,tab_word_0,out_bufx); 
	memcpy(tab_tmp_out,out_bufx,11*4);
	for(i=0;i<2;i++)
	{
		proces_copy(in_start[i],tab_tmp_in,out_buf);
		process_buf2(&d[2*i],&e[2*i],f[i],buf_word_out1,buf_word1,i);
		calcul_coeff(const_table_index[i],&var_word_491,&int_var,&out_word_ptr2);
		/*
		for(j=0;j<4;j++)
		{
			int cx = buf_word1[j];
			if(cx==1)
				sign[j] = 32767;
			else
			if(cx==-1)
				sign[j] = -32768;
			else
				sign[j] = 0; //???? unused
			
		}
		*/
		if(pulcod_buf_size>0)
		{
			int64_t l;
			l = int_var;
			for(j=0;j<pulcod_buf_size;j++)
			{
				int64_t x = 4*l*out_buf[j];
				if(x>2147450879L)
					x = 32767;
				else
				if(x<-2147450880L)
					x = -32768;
				else
				{
					x+=32768;
        			x>>=16;
				}
				buf_word_in[j]=x;
				tab_tmp_in[j+261]=x;
			}
		}
		
		int64_t l;
		l = out_word_ptr2;
		for(j=0;j<4;j++)
		{
			int64_t x = buf_word1[j];
			x *= l;
			x *= 32768;
			if(x>2147450879L)
				x = 32767;
			else
			if(x<-2147450880L)
				x = -32768;
			else
			{
				x+=32768;
        		x>>=16;
			}
			int xx;
			xx = x+tab_tmp_in[261+buf_word_out1[j]];
			if(xx>32767)
				xx = 32767;
			else
			if(xx<-32768)
				xx = -32768;
			tab_tmp_in[261+buf_word_out1[j]] = xx;
			
			x = 65534*x;
			if(x>2147450879L)
				x = 32767;
			else
			if(x<-2147450880L)
				x = -32768;
			else
			{
				x+=32768;
        		x>>=16;
			}
			
			xx = x+buf_word_in[buf_word_out1[j]];
			if(xx>32767)
				xx = 32767;
			else
			if(xx<-32768)
				xx = -32768;
			buf_word_in[buf_word_out1[j]]=xx;
		}
		
		for(j=0;j<261;j++)
		{
			tab_tmp_in[j]=tab_tmp_in[pulcod_buf_size+j];
		}
		calcul_64b_2(buf_word_in,buf_word_in1,tab_dword1_0,3,buf_local_in2);
		calul_bufs(buf_local_in2,buf_word_in1,tab_dword1,tab_dword2,buf_dword,tab_word,tab_int_22938,tab_int1,in_start[i]);
		calcul_64b(buf_dword,ptr_dword1,&pulcod_buf_end,2,buf_dword);  
		calcul_process(buf_local_in2,tab_int_16384,buf_dword);
		if(pulcod_buf_size>0)
		{
			for(j=0;j<pulcod_buf_size;j++)
			{
				int64_t x = buf_dword[j]; // word buf
				x*=2;
				
				if(x>32767)
					x = 32767;
				else
				if(x<-32768)
					x = -32768;
				pulcod_buf_2[pulcod_buf_size*i+j]=x;
			}
		}
		buf_word_in1 +=11;
	}
 return 0;
}

#define wav_add_long(a) out[i++] = a & 0xff;\
out[i++] = (a >> 8) & 0xff;\
out[i++] = (a >> 16) & 0xff;\
out[i++] = (a >> 24) & 0xff;\
	
int wave_header(uint8_t out[], int data_size, int freq)
{
	int file_size = data_size + 44 - 8;
	int i = 0;
	
	out[i++] = 'R';
	out[i++] = 'I';
	out[i++] = 'F';
	out[i++] = 'F';
	
	wav_add_long(file_size);
	
	out[i++] = 'W';
	out[i++] = 'A';
	out[i++] = 'V';
	out[i++] = 'E';
	
	out[i++] = 'f';
	out[i++] = 'm';
	out[i++] = 't';
	out[i++] = ' ';
	
	out[i++] = 16;
	out[i++] = 0;
	out[i++] = 0;
	out[i++] = 0;
	
	out[i++] = 1; // uncompressed
	out[i++] = 0;
	
	out[i++] = 1; // mono
	out[i++] = 0;

	wav_add_long(freq); // sample rate
	
	int byte_rate = freq*16*1/8;
	wav_add_long(byte_rate); // bps
	
	out[i++] = 2; // block aligment
	out[i++] = 0;
	
	out[i++] = 16; // bits per sample
	out[i++] = 0;

	out[i++] = 'd';
	out[i++] = 'a';
	out[i++] = 't';
	out[i++] = 'a';
	
	wav_add_long(data_size);

	return i;
}

int main(int argc, const char *argv[])
{
	
   if(argc < 2)
   {
      printf("nasced 1.0 \n\
Copyright (C) 2008-2010 Robert Mazur (rm@nateo.pl)\n\
Converts Olympus Digital Voice Recorder files to WAV files.\n\
License: GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>\n\
or\n\
License: Simplified BSD License\n\
Ussage: sandec [filename].raw\n");
      return -1;
   }   
   int ret, i;
      
   int fd, fd2; 
   uint8_t in[8*1024], out[32*1024];
   
   int len = 0, out_len = 0, data_size=0, quality = 0, freq=16000, pulcod_size=0, max_size=0;
   int bit_size = 16;
   int mode = 1;   
   
   fd = open(argv[1],O_RDONLY);
   if(fd<0)
   {
      printf("Unable to open '%s'!\n",argv[1]);
      return -1;
   }
 
  // 5 odvr\01
  // 13 fileinfo
   
   lseek(fd, 5+12, SEEK_SET);
   
   ret = read(fd, &quality, 1);   
   if(ret < 0) return -1;
   
   
   switch(quality)
   {
       case  0: freq = 10600; mode = 0; break;
       case  1: freq =  5750; mode = 0; break;
       case  2: freq = 16000; mode = 0; break;
       case  3: mode = 0; break;
       case  4: break;
       case  5: freq = 12000; pulcod_size = 36; mode = 2; max_size = 4032; break;
       case  6: freq =  7000; pulcod_size = 64; mode = 2; max_size = 7168; break;
       case  7: freq = 16000; pulcod_size = 24; mode = 2; max_size = 2688; break;
       case  8: freq = 16000; mode = 1; break;
       case  9: mode = 1; break;
       case 10: mode = 1; break;
   }
   
   if(pulcod_size)
   {
    ret = nas_ced_pulcod2_init(freq, pulcod_size);
    if(ret < 0)
    {
      printf("Pulcod2_init (%d,%d) failed!\n", freq, pulcod_size);
      return -1;
    }
   }
   
   char filename[512];
   mode_t omode = S_IRUSR | S_IWUSR;

   
   strncpy(filename, argv[1], 512);
   filename[511]=0;
   
   int str_len = strlen(filename);
   if(str_len < 4) str_len = 4;
   
   filename[str_len-0] = 0;
   filename[str_len-1] = 'v';
   filename[str_len-2] = 'a';
   filename[str_len-3] = 'w';
   filename[str_len-4] = '.';
   
   fd2 = open(filename, O_CREAT|O_WRONLY|O_EXCL,omode);
   if(fd2<0)
   {
      printf("Unable to open '%s'!\n", filename);
      return -1;
   }
   
   ret = wave_header(out, 0, freq);
 
   ret = write(fd2, out, ret);
  
   if(ret<0)
   {
      printf("Wave write error!\n");
      return -1;
   }
  
 
   do{
       
   len = 0;
   
   ret = read(fd, &len, 2);
   
   if(ret < 0) break;
   
   if(read(fd, in, len) <= 0) break;
   
   for(i=0; i<32*1024; i++) out[i] = 0;
 
   if(pulcod_size)
   {   
    int i;
    
    for(i = 2; i < 512; i += 256)
    {
     int k = 0;
     int count = 0;
     do
     {
        
      if(in[i+k] == 0x80)
      {
       int zero = 1, j;
        for(j = 1; j < 9; j++)
         if(in[i+k+j] != 0) zero = 0;
        if(zero) //silence to end
            break;
      }
     
      ret = nas_ced(in+i+k, (int16_t*)(out+out_len), mode, bit_size);
     
      if(ret >= 0)
      {
       out_len += ret*2;
       k += 9;
      }
     
     }while(++count < 28);
    }
    if(out_len < max_size)
     out_len = max_size;
           
   }
   else // ! pulcod2
   {
    ret = nas_ced(in+2, (int16_t*)(out+out_len), mode, bit_size);
     if(ret <= 0)
    break;
    out_len += ret*2;
   }
   
   ret = write(fd2, out, out_len);
   
   if(ret<0)
   {
      printf("Wave write error!\n");
      return -1;
   }
   
   data_size += out_len;
   out_len = 0;
   
   }while(len > 0);
       
   close(fd); 
   
   ret = lseek(fd2, 0, SEEK_SET);
   
   if(ret<0)
   {
      printf("Wave seek error!\n");
      return -1;
   }
   
   ret = wave_header(out, data_size, freq);
   
   ret = write(fd2, out, ret);
  
   if(ret<0)
   {
      printf("Wave write error!\n");
      return -1;
   }
   
   ret = close(fd2);
   
   if(ret<0)
   {
      printf("Wave close error!\n");
   }
   
   
    return 0;
} 